# -*- coding: utf-8 -*-

from lastuserapp.models import db, BaseMixin, UserPhone

__all__ = ['SMSMessage', 'SMS_STATUS']

class SMS_STATUS:
    QUEUED = 0
    PENDING = 1
    DELIVERED = 2
    FAILED = 3
    UNKNOWN = 4

class SMSMessage(db.Model, BaseMixin):
    __tablename__ = 'smsmessage'
    # Phone number that the message was sent to
    phone_number = db.Column(db.String(15), nullable=False)
    transaction_id = db.Column(db.Unicode(40), unique=True, nullable=True)
    # The message itself
    message = db.Column(db.Text, nullable=False)
    # Flags
    status = db.Column(db.Integer, default=0, nullable=False)
    status_at = db.Column(db.DateTime, nullable=True)
    fail_reason = db.Column(db.Unicode(25), nullable=True)
